"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unwrap = unwrap;
exports.bindActionCreator = bindActionCreator;
exports.bindActionCreators = bindActionCreators;
Object.defineProperty(exports, "createSource", {
  enumerable: true,
  get: function get() {
    return _createSource.default;
  }
});

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

var _createSource = _interopRequireDefault(require("./createSource"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var IS_ITERABLE_SENTINEL = '@@__IMMUTABLE_ITERABLE__@@';
var IS_RECORD_SENTINEL = '@@__IMMUTABLE_RECORD__@@';

function unwrap(state) {
  var isImmutable = state[IS_ITERABLE_SENTINEL] || state[IS_RECORD_SENTINEL];
  var wrapperName = isImmutable ? state.get('_autoWrapper') : state._autoWrapper;

  if (wrapperName) {
    if (isImmutable) {
      return unwrap(state.get(wrapperName));
    } else {
      return unwrap(state[state._autoWrapper]);
    }
  } else {
    return state;
  }
}

function bindActionCreator(actionCreator, dispatch) {
  return function () {
    return dispatch(actionCreator.apply(void 0, arguments));
  };
}

function bindActionCreators(actionCreators, dispatch) {
  var keys = Object.keys(actionCreators);
  var boundActionCreators = {};

  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    var actionCreator = actionCreators[key];

    if (typeof actionCreator === 'function') {
      boundActionCreators[key] = bindActionCreator(actionCreator, dispatch);
    } else if (_typeof(actionCreator) === 'object') {
      boundActionCreators[key] = bindActionCreators(actionCreator, dispatch);
    }
  }

  return boundActionCreators;
}